Index: main/channel.c
===================================================================
--- main/channel.c	(revision 197168)
+++ main/channel.c	(working copy)
@@ -3071,8 +3071,12 @@
 		while (timeout && chan->_state != AST_STATE_UP) {
 			struct ast_frame *f;
 			res = ast_waitfor(chan, timeout);
-			if (res <= 0) /* error, timeout, or done */
+			if (res == 0) { /* timeout, treat it like ringing */
+				*outstate = AST_CONTROL_RINGING;
 				break;
+			}
+			if (res < 0) /* error or done */
+				break;
 			if (timeout > -1)
 				timeout = res;
 			f = ast_read(chan);
